### Code accompanying the paper "Cryptographically secure multiparty evaluation
### of system reliability"

# These are utility functions which are available to all parties in the privacy
# preserving protocol.

library("gmp")

# Integer encoding of real values
mu <- function(kappa, y) {
  round(10^kappa * y)
}
muinv <- function(kappa, y) {
  as.double(as.bigq(10^-kappa) * as.bigq(y))
}

# Non-parametric Bayesian posterior for component test data
component.posterior <- function(M, l, t, data, alpha=1, beta=1) {
  s <- sum(data>t)
  n <- length(data)
  choose(M,l) * beta(l+alpha+s, M-l+beta+n-s) / beta(alpha+s, beta+n-s)
}
